<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item label="流程名称" prop="procDefName">
        <el-input
          v-model="queryParams.procDefName"
          placeholder="请输入流程名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="所属项目" prop="businessKey" v-if="showPro">
        <el-select
          v-model="queryParams.businessKey"
          placeholder="请选择所属项目"
          filterable
          clearable
        >
          <el-option
            v-for="(item, index) in projectOptions"
            :key="index"
            :label="item.projectName"
            :value="item.id"
          >
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="流程类型" prop="category">
        <el-select
          v-model="queryParams.category"
          @keyup.enter.native="handleQuery"
          placeholder="请选择流程类型"
          clearable
        >
          <el-option
            v-for="dict in dict.type.sys_process_category"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="申请时间">
        <el-date-picker
          v-model="daterangeCheckTime"
          style="width: 240px"
          value-format="yyyy-MM-dd"
          type="daterange"
          range-separator="-"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
        ></el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['system:deployment:add']"
          >新增流程</el-button
        >
      </el-col>
      <!-- <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['system:deployment:remove']"
        >删除</el-button>
      </el-col> -->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>
    <el-tabs type="card" v-model="activeName" @tab-click="handleClick">
      <el-tab-pane :label="tabs.all" name="all"></el-tab-pane>
      <el-tab-pane :label="tabs.await" name="await"></el-tab-pane>
      <el-tab-pane :label="tabs.finished" name="finished"></el-tab-pane>
    </el-tabs>
    <el-table
      v-loading="loading"
      :data="myProcessList"
      @selection-change="handleSelectionChange"
      stripe
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column
        label="项目名称"
        align="center"
        prop="businessKeyName"
        width="160"
        :show-overflow-tooltip="true"
      />
      <el-table-column
        label="申请编号"
        align="center"
        prop="procInsId"
        width="120"
        :show-overflow-tooltip="true"
      />
      <el-table-column
        label="流程名称"
        align="center"
        prop="procDefName"
        width="120"
        :show-overflow-tooltip="true"
      />
      <el-table-column label="流程类别" align="center" prop="category">
        <template slot-scope="scope">
          <dict-tag
            :options="dict.type.sys_process_category"
            :value="scope.row.category"
          />
        </template>
      </el-table-column>
      <el-table-column label="流程版本" align="center" width="80">
        <template slot-scope="scope">
          <el-tag size="medium">v{{ scope.row.procDefVersion }}</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="提交时间" align="center" prop="createTime" width="180" />
      <el-table-column label="流程状态" align="center" width="100">
        <template slot-scope="scope">
          <el-tag v-if="scope.row.finishTime == null" size="mini">进行中</el-tag>
          <el-tag
            type="success"
            v-if="scope.row.finishTime != null && scope.row.assigneeId != null"
            size="mini"
            >已完成</el-tag
          >
          <el-tag
            type="danger"
            v-if="scope.row.finishTime != null && scope.row.assigneeId == null"
            size="mini"
            >已终止</el-tag
          >
        </template>
      </el-table-column>
      <el-table-column label="当前节点" align="center" prop="taskName">
        <template slot-scope="scope">
          <div v-if="scope.row.finishTime == null">{{ scope.row.taskName }}</div>
          <div v-if="scope.row.finishTime != null">流程结束</div>
        </template>
      </el-table-column>
      <el-table-column label="处理耗时" align="center" prop="duration" width="150">
        <template slot-scope="scope">
          {{ getDurationDate(scope.row) }}
        </template>
      </el-table-column>
      <el-table-column label="办理人" align="center" width="200">
        <template slot-scope="scope">
          <label v-if="scope.row.assigneeName"
            >{{ scope.row.assigneeName }}
            <el-tag type="info" size="mini">{{
              scope.row.assigneeDeptName
            }}</el-tag></label
          >
        </template>
      </el-table-column>
      <el-table-column
        label="操作"
        width="200"
        align="center"
        fixed="right"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            v-if="getActivate(scope.row)"
            @click="handleActivate(scope.row)"
            type="text"
            size="small"
            icon="el-icon-edit-outline"
            >处理</el-button
          >
          <el-button
            @click="handleFlowRecord(scope.row)"
            type="text"
            size="small"
            icon="el-icon-finished"
            >详情</el-button
          >
          <el-button
            v-if="scope.row.finishTime == null"
            @click="handleStop(scope.row)"
            type="text"
            size="small"
            icon="el-icon-switch-button"
            >终止</el-button
          >
          <el-button
            v-if="scope.row.finishTime == null || superAdmin"
            @click="handleDelete(scope.row)"
            type="text"
            size="small"
            icon="el-icon-delete"
            v-hasPermi="['system:deployment:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 发起流程 -->
    <el-dialog
      :title="title"
      :visible.sync="open"
      width="60%"
      append-to-body
      :close-on-click-modal="false"
      :close-on-press-escape="false"
    >
      <el-form
        :model="queryProcessParams"
        ref="queryProcessForm"
        :inline="true"
        v-show="showSearch"
        label-width="68px"
      >
        <el-form-item label="流程名称" prop="name">
          <el-input
            v-model="queryProcessParams.name"
            placeholder="请输入流程名称"
            clearable
            size="small"
            @keyup.enter.native="handleProcessQuery"
          />
        </el-form-item>
        <el-form-item label="流程类型" prop="category">
          <el-select
            v-model="queryProcessParams.category"
            @keyup.enter.native="handleProcessQuery"
            placeholder="请选择流程类型"
            clearable
          >
            <el-option
              v-for="dict in dict.type.sys_process_category"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item>
          <el-button
            type="primary"
            icon="el-icon-search"
            size="mini"
            @click="handleProcessQuery"
            >搜索</el-button
          >
          <el-button icon="el-icon-refresh" size="mini" @click="resetProcessQuery"
            >重置</el-button
          >
        </el-form-item>
      </el-form>
      <el-table v-loading="processLoading" fit :data="definitionList" border>
        <el-table-column
          label="流程名称"
          align="center"
          prop="name"
          width="400"
          :show-overflow-tooltip="true"
        />
        <el-table-column label="流程版本" align="center">
          <template slot-scope="scope">
            <el-tag size="medium">v{{ scope.row.version }}</el-tag>
          </template>
        </el-table-column>
        <el-table-column label="流程分类" align="center" prop="category">
          <template slot-scope="scope">
            <dict-tag
              :options="dict.type.sys_process_category"
              :value="scope.row.category"
            />
          </template>
        </el-table-column>
        <el-table-column
          label="操作"
          align="center"
          width="300"
          class-name="small-padding fixed-width"
        >
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-edit-outline"
              @click="handleStartProcess(scope.row)"
              >发起流程</el-button
            >
          </template>
        </el-table-column>
      </el-table>
      <pagination
        v-show="processTotal > 0"
        :total="processTotal"
        :page.sync="queryProcessParams.pageNum"
        :limit.sync="queryProcessParams.pageSize"
        @pagination="myDefinitionList"
      />
    </el-dialog>
    <!-- 终止流程 -->
    <el-dialog
      :title="title"
      :visible.sync="stopOpen"
      width="30%"
      append-to-body
      :close-on-click-modal="false"
      :close-on-press-escape="false"
    >
      <el-form
        ref="form"
        :model="form"
        :rules="rules"
        v-loading="stopLoading"
        label-width="80px"
      >
        <el-form-item label="终止原因" prop="comment">
          <el-input
            type="textarea"
            v-model="form.comment"
            placeholder="请输入终止原因"
            rows="5"
          />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="handleStopClick">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <initTaskDrawer ref="initTaskDrawer" :closeCallBack="getList"></initTaskDrawer>
    <initLeaveTaskDrawer
      ref="initLeaveTaskDrawer"
      :closeCallBack="getList"
    ></initLeaveTaskDrawer>
    <editTaskDrawer ref="editTaskDrawer" :closeCallBack="getList"></editTaskDrawer>
    <editLeaveTaskDrawer
      ref="editLeaveTaskDrawer"
      :closeCallBack="getList"
    ></editLeaveTaskDrawer>
    <detailDrawer ref="detailDrawer"></detailDrawer>
    <detailLeaveDrawer ref="detailLeaveDrawer"></detailLeaveDrawer>
  </div>
</template>

<script>
import {
  getDeployment,
  delDeployment,
  addDeployment,
  updateDeployment,
  exportDeployment,
  flowRecord,
} from "@/api/flowable/finished";
import { myProcessList, stopProcess } from "@/api/flowable/process";
import { allList, queryCount } from "@/api/flowable/businessKey";
import { myDefinitionList } from "@/api/flowable/definition";
import initTaskDrawer from "./initTaskDrawer.vue";
import initLeaveTaskDrawer from "./initLeaveTaskDrawer.vue";
import editTaskDrawer from "./editTaskDrawer.vue";
import editLeaveTaskDrawer from "./editLeaveTaskDrawer.vue";
import detailDrawer from "./detail/detailDrawer.vue";
import detailLeaveDrawer from "./detail/detailLeaveDrawer.vue";
export default {
  name: "Deploy",
  components: {
    initTaskDrawer,
    initLeaveTaskDrawer,
    detailDrawer,
    detailLeaveDrawer,
    editTaskDrawer,
    editLeaveTaskDrawer,
  },
  dicts: ["sys_process_category"],
  data() {
    return {
      // 遮罩层
      loading: true,
      stopLoading: false,
      processLoading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      processTotal: 0,
      // 我发起的流程列表数据
      myProcessList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      stopOpen: false,
      src: "",
      definitionList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        procDefName: null,
        category: null,
        params: null,
        businessKey: null,
        activeName: null,
      },
      // 查询参数
      queryProcessParams: {
        pageNum: 1,
        pageSize: 10,
        name: null,
        category: null,
        key: null,
        tenantId: null,
        deployTime: null,
        derivedFrom: null,
        derivedFromRoot: null,
        parentDeploymentId: null,
        engineVersion: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        comment: [
          { required: true, message: "请输入终止原因", trigger: "blur" },
          {
            max: 500,
            message: "终止原因最多输入500字",
            trigger: "blur",
          },
        ],
      },
      daterangeCheckTime: [],
      tabs: {
        all: "全部申请（0）",
        await: "进行中（0）",
        finished: "已完成（0）",
      },
      activeName: "await",
      showPro: false,
      projectOptions: null,
      superAdmin: false,
    };
  },
  created() {
    let myMinRoles = this.$store.getters.roles;
    if (myMinRoles.includes("admin") || myMinRoles.includes("super")) {
      this.superAdmin = true;
    }
    this.queryParams.activeName = this.activeName;
    this.getList();
    this.initMyProject();
  },
  methods: {
    /** 查询流程定义列表 */
    getList() {
      this.loading = true;
      this.queryParams.params = {};
      if (null != this.daterangeCheckTime && "" != this.daterangeCheckTime) {
        this.queryParams.params["beginDate"] = this.daterangeCheckTime[0];
        this.queryParams.params["endDate"] = this.daterangeCheckTime[1];
      }
      this.queryCount(this.queryParams);
      allList(this.queryParams).then((response) => {
        this.myProcessList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 统计 */
    queryCount(params) {
      queryCount(params).then((response) => {
        this.tabs.await = "进行中（" + response.data.await + "）";
        this.tabs.finished = "已完成（" + response.data.finished + "）";
        this.tabs.all =
          "全部申请（" +
          (parseInt(response.data.await) + parseInt(response.data.finished)) +
          "）";
      });
    },
    // 查询和我相关的项目信息
    initMyProject() {
      // 获取项目列表的接口
      this.$api.publics.getMyProjectList({}).then((response) => {
        this.projectOptions = response.rows;
        if (response.rows.length > 1) {
          this.showPro = true;
        }
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.stopOpen = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        name: null,
        category: null,
        key: null,
        tenantId: null,
        deployTime: null,
        derivedFrom: null,
        derivedFromRoot: null,
        parentDeploymentId: null,
        engineVersion: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.daterangeCheckTime = [];
      this.handleQuery();
    },
    /** 搜索按钮操作 */
    handleProcessQuery() {
      this.queryProcessParams.pageNum = 1;
      this.myDefinitionList();
    },
    /** 重置按钮操作 */
    resetProcessQuery() {
      this.resetForm("queryProcessForm");
      this.handleProcessQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.procInsId);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.open = true;
      this.title = "发起流程";
      this.myDefinitionList();
    },
    myDefinitionList() {
      myDefinitionList(this.queryProcessParams).then((response) => {
        this.definitionList = response.data.records;
        this.processTotal = response.data.total;
        this.processLoading = false;
      });
    },
    /**  发起流程申请 */
    handleStartProcess(row) {
      this.open = false;
      if (row.flowKey == "flow_xmglzdl_qjspb") {
        this.$refs.initLeaveTaskDrawer.show(row);
      } else {
        this.$refs.initTaskDrawer.show(row);
      }
      // this.$router.push({ path: '/flowable/task/myProcess/send/index',
      //   query: {
      //     deployId: row.deploymentId,
      //     procDefId: row.id
      //     }
      // })
    },
    /**  继续办理 */
    handleActivate(row) {
      if (row.procDefKey == "flow_xmglzdl_qjspb") {
        this.$refs.editLeaveTaskDrawer.show(row);
      } else {
        this.$refs.editTaskDrawer.show(row);
      }
    },
    /**  判断是否继续办理 */
    getActivate(row) {
      if (row.taskName == "提交申请" && row.assigneeId == this.$store.getters.userId) {
        return true;
      } else {
        return false;
      }
    },
    /**  取消流程申请 */
    handleStop(row) {
      this.form.taskId = row.taskId;
      this.form.userId = this.$store.getters.userId;
      this.form.instanceId = row.procInsId;
      this.stopOpen = true;
    },
    /**  取消流程申请 */
    handleStopClick() {
      let that = this;
      this.$refs["form"].validate((valid) => {
        if (valid) {
          this.$modal
            .confirm("是否终止当前流程申请？")
            .then(function () {
              that.stopLoading = true;
              return stopProcess(that.form);
            })
            .then((res) => {
              that.$modal.msgSuccess(res.msg);
              that.stopLoading = false;
              that.stopOpen = false;
              that.getList();
            });
        }
      });
    },
    /** 流程流转记录 */
    handleFlowRecord(row) {
      //根据不同业务跳转不同表单
      if (row.procDefKey == "flow_xmglzdl_qjspb") {
        this.$refs.detailLeaveDrawer.show(row);
      } else {
        this.$refs.detailDrawer.show(row);
      }
      // this.$router.push({ path: '/flowable/task/myProcess/detail/index',
      //   query: {
      //     procInsId: row.procInsId,
      //     deployId: row.deployId,
      //     taskId: row.taskId
      // }})
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getDeployment(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改流程定义";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateDeployment(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addDeployment(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.procInsId || this.ids; // 暂不支持删除多个流程
      this.$confirm(
        '是否确认删除流程定义编号为"' + ids + '"的数据项?删除后数据将不可找回！！',
        "警告",
        {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        }
      )
        .then(() => {
          this.loading = true;
          return delDeployment(ids);
        })
        .then(() => {
          this.loading = false;
          this.getList();
          this.$modal.msgSuccess("删除成功");
        });
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有流程定义数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          return exportDeployment(queryParams);
        })
        .then((response) => {
          this.download(response.msg);
        });
    },
    // 页签点击
    handleClick() {
      this.queryParams.activeName = this.activeName;
      this.getList();
    },
    getDurationDate(row) {
      let day = 0;
      let hours = 0;
      let min = row.duration;
      if (min > 1440) {
        day = parseInt(min / 1440);
        min = min % 1440;
        if (min > 60) {
          hours = parseInt(min / 60);
          min = min % 60;
        }
      } else if (min > 60) {
        hours = parseInt(min / 60);
        min = min % 60;
      }
      if (day > 0) {
        if (day < 10) day = "0" + day;
        if (hours < 10) hours = "0" + hours;
        if (min < 10) min = "0" + min;
        return day + "天" + hours + "小时" + min + "分钟";
      }
      if (hours > 0) {
        if (hours < 10) hours = "0" + hours;
        if (min < 10) min = "0" + min;
        return hours + "小时" + min + "分钟";
      }
      if (min > 0) {
        if (min < 10) min = "0" + min;
        return min + "分钟";
      }
      if (min == 0) {
        return "1分钟";
      }
    },
  },
};
</script>
